#ifndef FFXMATHS_H__
#define FFXMATHS_H__

inline float InvSqrt(float x)
{
   float result;
   __asm__ volatile (
      "mtv     %1, S000\n"
      "vrsq.s S000, S000\n"
      "mfv     %0, S000\n"
   : "=r"(result) : "r"(x));

   return result;
} 

inline float Sqrt(float x)
{
    float result;

    __asm__ volatile (
            "mtv %1, S000\n"
            "vsqrt.s S001, S000\n"
            "mfv %0, S001\n"
    : "=r"(result) : "r"(x) );

    return result;
}

static inline float frand()
{
	int x = (rand()*rand()) & 0x007fffff;
	x |= 0x3f800000;				// 1.0f in IEEE fp
	return (*(float*)&x) - 1.0f;
}

// Returns in rand -1 .. +1
static inline float frand_11()
{
	return (frand() * 2.0f) - 1.0f;
}

static inline float frand_range( float lo, float hi )
{
	return lo + (hi - lo) * frand();
}

#endif // FFXMATHS_H__
