/*
Copyright (C) 2007 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "stdafx.h"
#include "UIElement.h"

#include "UIContext.h"

//*************************************************************************************
//
//*************************************************************************************
CUIElement::~CUIElement()
{
}

//*************************************************************************************
//
//*************************************************************************************
CUIElementBag::CUIElementBag()
{

}

//*************************************************************************************
//
//*************************************************************************************
CUIElementBag::~CUIElementBag()
{
	for( u32 i = 0; i < mElements.size(); ++i )
	{
		delete mElements[ i ];
	}
}

//*************************************************************************************
//
//*************************************************************************************
void CUIElementBag::Draw( CUIContext * context, s32 min_x, s32 max_x, s32 y, u32 selected_idx )
{
	for( u32 i = 0; i < mElements.size(); ++i )
	{
		const CUIElement *	element( mElements[ i ] );

		element->Draw( context, min_x, max_x, y, i == selected_idx );
		y += element->GetHeight( context );
	}
}
