// allows GCC to compile Microsoft C/C++ source files and Platform SDK headers
// gnu w32api is *not* supported

#ifndef _M_IX86
#if defined(__i786__)
#define _M_IX86 700
#elif defined(__i686__)
#define _M_IX86 600
#elif defined(__i586__)
#define _M_IX86 500
#elif defined(__i486__)
#define _M_IX86 400
#elif defined(__i386__)
#define _M_IX86 300
#endif
#endif

#if defined(_M_IX86) && !defined(_X86_)
#define _X86_
#endif

#if defined(__ia64__) || defined(_M_IA64) || defined(_IA64_)
#ifndef __ia64__
#define __ia64__
#endif
#ifndef _M_IA64
#define _M_IA64
#endif
#ifndef _IA64_
#define _IA64_
#endif
#endif

#if defined(__alpha__) || defined(_M_ALPHA) || defined(_ALPHA_)
#ifndef __alpha__
#define __alpha__
#endif
#ifndef _M_ALPHA
#define _M_ALPHA
#endif
#ifndef _ALPHA_
#define _ALPHA_
#endif
#endif

#if defined(__PPC__) || defined(_M_PPC) || defined(_PPC_)
#ifndef __PPC__
#define __PPC__
#endif
#ifndef _M_PPC
#define _M_PPC
#endif
#ifndef _PPC_
#define _PPC_
#endif
#endif

#if defined(__mips) || defined(_M_MRX000) || defined(_MIPS_)
#ifndef __mips
#define __mips
#endif
#ifndef _M_MRX000
#define _M_MRX000
#endif
#ifndef _MIPS_
#define _MIPS_
#endif
#endif

#if defined(__m68k__) || defined(_M_M68K) || defined(_68K_)
#ifndef __m68k__
#define __m68k__
#endif
#ifndef _M_M68K
#define _M_M68K
#endif
#ifndef _68K_
#define _68K_
#endif
#endif

#ifdef __GCC_MUST_BE_WIN3264__
#ifndef __GCC_MUST_BE_WIN32__
#define __GCC_MUST_BE_WIN32__
#endif
#ifndef __GCC_MUST_BE_WIN64__
#define __GCC_MUST_BE_WIN64__
#endif
#endif

#if defined(__GCC_WANT_WIN3264_IF_CYGWIN__) || defined(__GCC_MUST_BE_WIN32__) || defined(__GCC_MUST_BE_WIN64__)
#if defined(__CYGWIN32__) && !defined(WIN32)
#define WIN32
#endif
#if defined(__CYGWIN64__) && !defined(WIN64)
#define WIN64
#endif
#endif

#if defined(WIN32) || defined(_WIN32) || defined(__WIN32) || defined(__WIN32__)
#ifndef WIN32
#define WIN32
#endif
#ifndef _WIN32
#define _WIN32
#endif
#ifndef __WIN32
#define __WIN32
#endif
#ifndef __WIN32__
#define __WIN32__
#endif
#endif

#if defined(WIN64) || defined(_WIN64) || defined(__WIN64) || defined(__WIN64__)
#ifndef WIN64
#define WIN64
#endif
#ifndef _WIN64
#define _WIN64
#endif
#ifndef __WIN64
#define __WIN64
#endif
#ifndef __WIN64__
#define __WIN64__
#endif
#endif

#if defined(__GCC_MUST_BE_WIN32__) && defined(__GCC_MUST_BE_WIN64__) && !defined(WIN32) && !defined(WIN64)
#error Sorry, this program only runs on Win32 (Windows 95/98/Me/NT/2000/XP) or Win64 (Windows XP 64-bit)
#endif

#if defined(__GCC_MUST_BE_WIN32__) && !defined(__GCC_MUST_BE_WIN64__) && !defined(WIN32)
#error Sorry, this program only runs on Win32 (Windows 95/98/Me/NT/2000/XP)
#endif

#if defined(__GCC_MUST_BE_WIN32__) && !defined(__GCC_MUST_BE_WIN64__) && !defined(WIN64)
#error Sorry, this program only runs on Win64 (Windows XP 64-bit)
#endif

#pragma message("Hello, hello!!!")

#ifdef __GCC_WIN64_UNTESTED__
#pragma message("Warning: this program may build or run incorrectly on Win64")
#endif

#if defined(_M_IX86) && defined(_M_IA64)
#error Cannot target both IA-32 and IA-64
#endif

#if defined(_WIN32) && defined(_WIN64)
#error Cannot target both Win32 and Win64
#endif

#if defined(_WIN64) && !defined(_M_IA64)
#error Win64 targeted without targeting IA-64
#endif

#ifdef __GNUC__
#ifndef __GCC_WINDOWS_COMPATIBILITY_HEADER__
#define __GCC_WINDOWS_COMPATIBILITY_HEADER__

#define _STDCALL_SUPPORTED

#define __int8 char
#define __int16 short
#define __int32 long
#define __int64 long long
#define __assume(x) do {} while(0)
#define __forceinline inline

// TODO: find a suitable replacement supported by GCC
#define _ASSERTE(x) x

#if defined(_WIN32) || defined(_WIN64)
/*
// very dirty way to detect GNU w32api vs Microsoft headers (cygwin defines _CPLEXT_H)
#include <cplext.h>
#ifdef _INC_CPLEXT
#define __GNU_MS_WIN__
//#else
//#define __GNU_CYGWIN_W32API__
#endif
*/

#define __USE_W32_SOCKETS
#ifdef _cplusplus
#include <cstring>
#include <algorithm>
using namespace std;
#endif

// all this code is used to avoid compiling Microsoft-style __asm code
#ifdef _M_IX86
// included here to avoid having MIDL_PASS defined
#include <ctype.h>  
#include <basetsd.h>
#include <guiddef.h>

// MIDL_PASS is defined to avoid x86 inline assembly in winnt.h. SID declaration must be disabled since it conditionally uses MIDL attributes when MIDL_PASS is defined

#define SID_DEFINED

#define MIDL_PASS
// includes winnt.h
#define NOMINMAX
#include <windef.h>
#undef NOMINMAX
#undef MIDL_PASS

#ifdef DECLSPEC_IMPORT
#undef DECLSPEC_IMPORT
#endif
#define DECLSPEC_IMPORT __attribute__((dllimport))

#ifdef DECLSPEC_NORETURN
#undef DECLSPEC_NORETURN
#endif
#define DECLSPEC_NORETURN __attribute__((noreturn))

typedef struct _SID {
   BYTE  Revision;
   BYTE  SubAuthorityCount;
   SID_IDENTIFIER_AUTHORITY IdentifierAuthority;
   DWORD SubAuthority[ANYSIZE_ARRAY];
} SID, *PISID;
#endif //_M_IX86

#ifndef WIN32_LEAN_AND_MEAN
#define _OLE2_H_
#endif
#include <windows.h>
#ifndef WIN32_LEAN_AND_MEAN
#undef _OLE2_H_
#endif

#define _MSC_VER 1000
#define bool _bool_value
#include <wtypes.h>
#undef _VARIANT_BOOL
typedef VARIANT_BOOL _VARIANT_BOOL;
#include <oaidl.h>
#undef bool
#undef _MSC_VER

// GCC doesn't like the Microsoft definitons of these
#define ULONGLONG unsigned long long
#define LONGLONG signed long long
// Note: since we had to define MIDL_PASS we get a definition of (U)LARGE_INTEGER that only contains QuadPart

#endif // defined(_WIN32) || defined(_WIN64)

#define _strcmpi strcasecmp
#define _isnan isnan

// Cygwin doesn't declare _strlwr and _strupr but they are present
#ifdef _cplusplus
extern "C" {
#endif
__cdecl char* _strlwr(char* p);
__cdecl char* _strupr(char* p);
#ifdef _cplusplus
}
#endif

#endif //__GCC_WINDOWS_COMPATIBILITY_HEADER__
#endif // __GNUC__
